=== modified file 'NEWS'
--- NEWS	2007-03-28 05:19:01 +0000
+++ NEWS	2007-03-28 23:28:21 +0000
@@ -11,6 +11,9 @@
       requires an explicit action using a ChrootServer.
       (Robert Collins, Andrew Bennetts)
 
+    * Deprecate Branch.get_root_id() because branches don't have root ids,
+      rather than fixing bug #96847.  (Aaron Bentley)
+
   TESTING:
 
     * Added ``bzrlib.strace.strace`` which will strace a single callable and

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2007-03-27 05:53:02 +0000
+++ bzrlib/branch.py	2007-03-28 23:28:21 +0000
@@ -58,7 +58,7 @@
                                       deprecated_method,
                                       DEPRECATED_PARAMETER,
                                       deprecated_passed,
-                                      zero_eight, zero_nine,
+                                      zero_eight, zero_nine, zero_sixteen,
                                       )
 from bzrlib.trace import mutter, note
 
@@ -297,8 +297,13 @@
             raise InvalidRevisionNumber(revno)
         return self.repository.get_revision_delta(rh[revno-1])
 
+    @deprecated_method(zero_sixteen)
     def get_root_id(self):
-        """Return the id of this branches root"""
+        """Return the id of this branches root
+
+        Deprecated: branches don't have root ids-- trees do.
+        Use basis_tree().get_root_id() instead.
+        """
         raise NotImplementedError(self.get_root_id)
 
     def print_file(self, file, revision_id):
@@ -1220,6 +1225,8 @@
         """See Branch.abspath."""
         return self.control_files._transport.abspath(name)
 
+
+    @deprecated_method(zero_sixteen)
     @needs_read_lock
     def get_root_id(self):
         """See Branch.get_root_id."""

=== modified file 'bzrlib/symbol_versioning.py'
--- bzrlib/symbol_versioning.py	2007-01-16 15:56:53 +0000
+++ bzrlib/symbol_versioning.py	2007-03-27 13:26:24 +0000
@@ -34,6 +34,7 @@
            'zero_thirteen',
            'zero_fourteen',
            'zero_fifteen',
+           'zero_sixteen',
            ]
 
 from warnings import warn
@@ -49,6 +50,7 @@
 zero_thirteen = "%s was deprecated in version 0.13."
 zero_fourteen = "%s was deprecated in version 0.14."
 zero_fifteen = "%s was deprecated in version 0.15."
+zero_sixteen = "%s was deprecated in version 0.16."
 
 
 def set_warning_method(method):

